/*
todo:

  enum support?

  check out dsp.c for signal processing stuff

  use log where I have verbose if appropriate

  make this res_php

  php fatal errors crash *

  make boolean where int should be boolean

  NEED TO DOCUMENT NO THE WIKI

  default script directory

  realtime callback?

*/

/*
   +----------------------------------------------------------------------+
   | PHP Version 4                                                        |
   +----------------------------------------------------------------------+
   | Copyright (c) 1997-2003 The PHP Group                                |
   +----------------------------------------------------------------------+
   | This source file is subject to version 2.02 of the PHP license,      |
   | that is bundled with this package in the file LICENSE, and is        |
   | available at through the world-wide-web at                           |
   | http://www.php.net/license/2_02.txt.                                 |
   | If you did not receive a copy of the PHP license and are unable to   |
   | obtain it through the world-wide-web, please send a note to          |
   | license@php.net so we can mail you a copy immediately.               |
   +----------------------------------------------------------------------+
   | Author: David Eder <david@eder.us>                                   |
   +----------------------------------------------------------------------+
*/

#include "php_asterisk.h"

extern void asterisk_log(char *,char *);
extern struct ast_channel *asterisk_get_channel_by_name(char *);

/*******************/
/* PHP module part */
/*******************/

#ifdef POST_10
#define ast_set_read_format_a(chan,fmt) ast_set_read_format(chan,fmt,0);
#define ast_set_write_format_a(chan,fmt) ast_set_write_format(chan,fmt,0);
#else
#define ast_set_read_format_a(chan,fmt) ast_set_read_format(chan,fmt);
#define ast_set_write_format_a(chan,fmt) ast_set_write_format(chan,fmt);
#endif

PHP_MINFO_FUNCTION(asterisk);

PHP_FUNCTION(asterisk_answer);
PHP_FUNCTION(asterisk_best_codec);
PHP_FUNCTION(asterisk_bridge_call);
PHP_FUNCTION(asterisk_chanlist);
PHP_FUNCTION(asterisk_channel_make_compatible);
PHP_FUNCTION(asterisk_channel_setoption);
PHP_FUNCTION(asterisk_channel_status);
PHP_FUNCTION(asterisk_cli);
PHP_FUNCTION(asterisk_codec2str);
PHP_FUNCTION(asterisk_control_streamfile);
PHP_FUNCTION(asterisk_db_del);
PHP_FUNCTION(asterisk_db_deltree);
PHP_FUNCTION(asterisk_db_get);
PHP_FUNCTION(asterisk_db_put);
PHP_FUNCTION(asterisk_exec);
PHP_FUNCTION(asterisk_getdata);
PHP_FUNCTION(asterisk_getformatbyname);
PHP_FUNCTION(asterisk_getformatname);
PHP_FUNCTION(asterisk_get_priority);
PHP_FUNCTION(asterisk_get_variable);
PHP_FUNCTION(asterisk_get_variables);
PHP_FUNCTION(asterisk_hangup);
PHP_FUNCTION(asterisk_log);
PHP_FUNCTION(asterisk_manager_command);
PHP_FUNCTION(asterisk_moh_start);
PHP_FUNCTION(asterisk_moh_stop);
PHP_FUNCTION(asterisk_recvchar);
PHP_FUNCTION(asterisk_request);
PHP_FUNCTION(asterisk_request_and_dial);
PHP_FUNCTION(asterisk_say_character_str);
PHP_FUNCTION(asterisk_say_date);
PHP_FUNCTION(asterisk_say_datetime);
PHP_FUNCTION(asterisk_say_datetime_from_now);
PHP_FUNCTION(asterisk_say_digit_str);
PHP_FUNCTION(asterisk_say_number);
PHP_FUNCTION(asterisk_say_phonetic_str);
PHP_FUNCTION(asterisk_say_time);
PHP_FUNCTION(asterisk_senddigit);
PHP_FUNCTION(asterisk_send_image);
PHP_FUNCTION(asterisk_sendtext);
PHP_FUNCTION(asterisk_set_best_read_format);
PHP_FUNCTION(asterisk_set_best_write_format);
PHP_FUNCTION(asterisk_set_callerid);
PHP_FUNCTION(asterisk_set_context);
PHP_FUNCTION(asterisk_set_extension);
PHP_FUNCTION(asterisk_set_priority);
PHP_FUNCTION(asterisk_set_read_format);
PHP_FUNCTION(asterisk_set_variable);
PHP_FUNCTION(asterisk_setwhentohangup);
PHP_FUNCTION(asterisk_set_write_format);
PHP_FUNCTION(asterisk_stream_file);
PHP_FUNCTION(asterisk_state2str);
PHP_FUNCTION(asterisk_tdd_mode);
PHP_FUNCTION(asterisk_verbose);
PHP_FUNCTION(asterisk_waitfor);
PHP_FUNCTION(asterisk_waitfordigit);

/* {{{ asterisk_functions[]
 *
 * Every user visible function must have an entry in asterisk_functions[].
 */
function_entry asterisk_functions[] = {
	PHP_FE(asterisk_answer     , NULL)
	PHP_FE(asterisk_best_codec, NULL)
	PHP_FE(asterisk_bridge_call, NULL)
	PHP_FE(asterisk_chanlist   , NULL)
	PHP_FE(asterisk_channel_make_compatible, NULL)
	PHP_FE(asterisk_channel_setoption, NULL)
	PHP_FE(asterisk_channel_status, NULL)
	PHP_FE(asterisk_cli        , NULL)
	PHP_FE(asterisk_codec2str        , NULL)
	PHP_FE(asterisk_control_streamfile, NULL)
	PHP_FE(asterisk_db_del      , NULL)
	PHP_FE(asterisk_db_deltree  , NULL)
	PHP_FE(asterisk_db_get      , NULL)
	PHP_FE(asterisk_db_put      , NULL)
	PHP_FE(asterisk_exec       , NULL)
	PHP_FE(asterisk_getdata    , NULL)
	PHP_FE(asterisk_getformatbyname    , NULL)
	PHP_FE(asterisk_getformatname    , NULL)
	PHP_FE(asterisk_get_priority   , NULL)
	PHP_FE(asterisk_get_variable, NULL)
	PHP_FE(asterisk_get_variables, NULL)
	PHP_FE(asterisk_hangup     , NULL)
	PHP_FE(asterisk_log        , NULL)
	PHP_FE(asterisk_manager_command, NULL)
	PHP_FE(asterisk_moh_start  , NULL)
	PHP_FE(asterisk_moh_stop   , NULL)
	PHP_FE(asterisk_recvchar   , NULL)
	PHP_FE(asterisk_request    , NULL)
	PHP_FE(asterisk_request_and_dial, NULL)
	PHP_FE(asterisk_say_character_str  , NULL)
	PHP_FALIAS(asterisk_say_character, asterisk_say_digit_str, NULL)
	PHP_FE(asterisk_say_date  , NULL)
	PHP_FE(asterisk_say_datetime  , NULL)
	PHP_FE(asterisk_say_datetime_from_now  , NULL)
	PHP_FE(asterisk_say_digit_str  , NULL)
	PHP_FALIAS(asterisk_say_digit, asterisk_say_digit_str, NULL)
	PHP_FE(asterisk_say_number  , NULL)
	PHP_FE(asterisk_say_phonetic_str  , NULL)
	PHP_FALIAS(asterisk_say_phonetic, asterisk_say_phonetic_str, NULL)
	PHP_FE(asterisk_say_time  , NULL)
	PHP_FE(asterisk_senddigit  , NULL)
	PHP_FE(asterisk_send_image  , NULL)
	PHP_FE(asterisk_sendtext   , NULL)
	PHP_FE(asterisk_set_best_read_format, NULL)
	PHP_FE(asterisk_set_best_write_format, NULL)
	PHP_FE(asterisk_set_callerid, NULL)
	PHP_FE(asterisk_set_context , NULL)
	PHP_FE(asterisk_set_extension, NULL)
	PHP_FE(asterisk_set_priority, NULL)
	PHP_FE(asterisk_set_read_format, NULL)
	PHP_FE(asterisk_set_variable, NULL)
	PHP_FE(asterisk_setwhentohangup , NULL)
	PHP_FALIAS(asterisk_set_autohangup, asterisk_setwhentohangup, NULL)
	PHP_FE(asterisk_set_write_format, NULL)
	PHP_FE(asterisk_stream_file , NULL)
	PHP_FE(asterisk_state2str , NULL)
	PHP_FE(asterisk_tdd_mode    , NULL)
	PHP_FE(asterisk_verbose    , NULL)
	PHP_FE(asterisk_waitfor    , NULL)
	PHP_FE(asterisk_waitfordigit, NULL)
	{ NULL, NULL, NULL }
};
/* }}} */

/* {{{ asterisk_module_entry
 */
zend_module_entry asterisk_module_entry = {
        STANDARD_MODULE_HEADER,
        "asterisk",
        asterisk_functions,
        NULL,
        NULL,
        NULL,
        NULL,
        PHP_MINFO(asterisk),
        NO_VERSION_YET,
        STANDARD_MODULE_PROPERTIES
};
/* }}} */

/* {{{ PHP_MINFO_FUNCTION
 */
PHP_MINFO_FUNCTION(asterisk)
{
        php_info_print_box_start(0);
        php_printf("<p>Asterisk PHP extension</p>\n");
        php_printf("<p>Version 0.1alpha (2005-06-09)</p>\n");
        php_printf("<p><b>Authors:</b></p>\n");
        php_printf("<p>David Eder &lt;david@eder.us&gt;</p>\n");
        php_info_print_box_end();

        DISPLAY_INI_ENTRIES();
}
/* }}} */


struct ast_channel *asterisk_get_channel_by_name(char *name)
{
	struct ast_channel *chan;
	chan = ast_get_channel_by_name_locked(name);
	if(chan) {
		ast_mutex_unlock(&chan->lock);
	}
	return(chan);
}

/* {{{ proto int asterisk_answer([string channel])
  Answer a channel */
PHP_FUNCTION(asterisk_answer)
{
	zval **args[1];
	zval channel;
	int arg_count = ZEND_NUM_ARGS();

	struct ast_channel * chan;

	if (arg_count > 1 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	if(arg_count < 1) {

		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));
	} else {
		convert_to_string_ex(args[0]);
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	if (chan->_state != AST_STATE_UP) {
		RETURN_LONG(ast_answer(chan));
	}

	RETURN_LONG(AST_STATE_UP);
}
/* }}} */


/* {{{ proto int asterisk_best_codec([string channel])
  Get best compatible code for this channel */
PHP_FUNCTION(asterisk_best_codec)
{
	zval **args[1];
	zval channel;
	int arg_count = ZEND_NUM_ARGS();

	struct ast_channel * chan;

	if(arg_count > 1 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	if(arg_count < 1) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));
	} else {
		convert_to_string_ex(args[0]);
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	RETURN_LONG(ast_best_codec(chan->nativeformats));
}
/* }}} */


/* {{{ proto int asterisk_bridge_call([string channel,] string peer[, array options])
  Bridge a call */
PHP_FUNCTION(asterisk_bridge_call)
{
/* TODO: test */
	zval **args[3];
	zval channel;
	zval *options;
	zval **zvalue;
	int arg_count = ZEND_NUM_ARGS();

	struct ast_channel * chan;
	struct ast_channel * pr;

	struct ast_bridge_config config;

	if (arg_count > 3 || arg_count < 1 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	convert_to_string_ex(args[0]);
	if(arg_count < 3) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));
		pr = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
	} else {
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
		convert_to_string_ex(args[1]);
		pr = asterisk_get_channel_by_name(Z_STRVAL_PP(args[1]));
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	if(!pr) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	memset(&config, 0, sizeof(struct ast_bridge_config));

	if(arg_count > 1) {
		options = *args[arg_count - 1];
		convert_to_array(options);

#ifdef AST_FLAG_BLOCKING

		if(zend_hash_find(Z_ARRVAL_P(options), "play_to_caller", sizeof("play_to_caller"), (void **) &zvalue) == SUCCESS)
		{
			convert_to_long_ex(zvalue);
			ast_set_flag(&(config.features_caller), Z_LVAL_PP(zvalue));
		}

		if(zend_hash_find(Z_ARRVAL_P(options), "play_to_callee", sizeof("play_to_callee"), (void **) &zvalue) == SUCCESS)
		{
			convert_to_long_ex(zvalue);
			ast_set_flag(&(config.features_caller), Z_LVAL_PP(zvalue));
		}

#else
		if(zend_hash_find(Z_ARRVAL_P(options), "play_to_caller", sizeof("play_to_caller"), (void **) &zvalue) == SUCCESS)
		{
			convert_to_long_ex(zvalue);
			config.play_to_caller = Z_LVAL_PP(zvalue);
		}

		if(zend_hash_find(Z_ARRVAL_P(options), "play_to_callee", sizeof("play_to_callee"), (void **) &zvalue) == SUCCESS)
		{
			convert_to_long_ex(zvalue);
			config.play_to_callee = Z_LVAL_PP(zvalue);
		}

		if(zend_hash_find(Z_ARRVAL_P(options), "allowredirect_in", sizeof("allowredirect_in"), (void **) &zvalue) == SUCCESS)
		{
			convert_to_long_ex(zvalue);
			config.allowredirect_in = Z_LVAL_PP(zvalue);
		}

		if(zend_hash_find(Z_ARRVAL_P(options), "allowredirect_out", sizeof("allowredirect_out"), (void **) &zvalue) == SUCCESS)
		{
			convert_to_long_ex(zvalue);
			config.allowredirect_out = Z_LVAL_PP(zvalue);
		}

		if(zend_hash_find(Z_ARRVAL_P(options), "allowdisconnect_in", sizeof("allowdisconnect_in"), (void **) &zvalue) == SUCCESS)
		{
			convert_to_long_ex(zvalue);
			config.allowdisconnect_in = Z_LVAL_PP(zvalue);
		}

		if(zend_hash_find(Z_ARRVAL_P(options), "allowdisconnect_out", sizeof("allowdisconnect_out"), (void **) &zvalue) == SUCCESS)
		{
			convert_to_long_ex(zvalue);
			config.allowdisconnect_out = Z_LVAL_PP(zvalue);
		}

#endif
		if(zend_hash_find(Z_ARRVAL_P(options), "timelimit", sizeof("timelimit"), (void **) &zvalue) == SUCCESS)
		{
			convert_to_long_ex(zvalue);
			config.timelimit = Z_LVAL_PP(zvalue);
		}

		if(zend_hash_find(Z_ARRVAL_P(options), "play_warning", sizeof("play_warning"), (void **) &zvalue) == SUCCESS)
		{
			convert_to_long_ex(zvalue);
			config.play_warning = Z_LVAL_PP(zvalue);
		}

		if(zend_hash_find(Z_ARRVAL_P(options), "warning_freq", sizeof("warning_freq"), (void **) &zvalue) == SUCCESS)
		{
			convert_to_long_ex(zvalue);
			config.warning_freq = Z_LVAL_PP(zvalue);
		}

		if(zend_hash_find(Z_ARRVAL_P(options), "warning_sound", sizeof("warning_sound"), (void **) &zvalue) == SUCCESS)
		{
			convert_to_string_ex(zvalue);
			config.warning_sound = Z_STRVAL_PP(zvalue);
		}

		if(zend_hash_find(Z_ARRVAL_P(options), "end_sound", sizeof("end_sound"), (void **) &zvalue) == SUCCESS)
		{
			convert_to_string_ex(zvalue);
			config.end_sound = Z_STRVAL_PP(zvalue);
		}

		if(zend_hash_find(Z_ARRVAL_P(options), "start_sound", sizeof("start_sound"), (void **) &zvalue) == SUCCESS)
		{
			convert_to_string_ex(zvalue);
			config.start_sound = Z_STRVAL_PP(zvalue);
		}

		if(zend_hash_find(Z_ARRVAL_P(options), "firstpass", sizeof("firstpass"), (void **) &zvalue) == SUCCESS)
		{
			convert_to_long_ex(zvalue);
			config.firstpass = Z_LVAL_PP(zvalue);
		}
	}

	RETURN_LONG(ast_bridge_call(chan, pr, &config));
}
/* }}} */


/* {{{ proto int asterisk_chanlist(void)
  Channel list */
PHP_FUNCTION(asterisk_chanlist)
{
	struct ast_channel *c=NULL;
	int channels = 0;
	zval *channel;

	array_init(return_value);

	c = ast_channel_walk_locked(NULL);
	while(c) {
		MAKE_STD_ZVAL(channel);
		array_init(channel);

		add_assoc_string(channel, "channel",     c->name, 1);
		add_assoc_string(channel, "context",     c->context, 1);
		add_assoc_string(channel, "extension",   c->exten, 1);
		add_assoc_long(channel,   "priority",    c->priority);
		add_assoc_string(channel, "state",       ast_state2str(c->_state), 1);
		add_assoc_string(channel, "application", c->appl ? c->appl : "(None)", 1);
		add_assoc_string(channel, "data",        c->data ? (strlen(c->data) ? c->data : "(Empty)") : "(None)", 1);

		add_index_zval(return_value, channels++, channel);

		ast_mutex_unlock(&c->lock);
		c = ast_channel_walk_locked(c);
	}
}
/* }}} */


/* {{{ proto int asterisk_channel_make_compatible([string channel,] string peer)
  Make compatible */
PHP_FUNCTION(asterisk_channel_make_compatible)
{
/* TODO: test */
	zval **args[2];
	zval channel;
	int arg_count = ZEND_NUM_ARGS();
	struct ast_channel * chan;
	struct ast_channel * pr;

	if (arg_count > 2 || arg_count < 1 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	if(arg_count < 2) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));
	} else {
		convert_to_string_ex(args[0]);
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	convert_to_string_ex(args[arg_count - 1]);
	pr = asterisk_get_channel_by_name(Z_STRVAL_PP(args[arg_count - 1]));

	if(!pr) {
		ast_log(LOG_WARNING, "No Channels!\n");
		RETURN_LONG(-1);
	}

	RETURN_LONG(ast_channel_make_compatible(chan, pr));
}
/* }}} */


/* {{{ proto int asterisk_channel_setoption([string channel,] int option, string data)
  Set a channel option */
PHP_FUNCTION(asterisk_channel_setoption)
{
/* todo: test */
	zval zchan;
	char * channel;
	int channel_len;
	int option;
	char * data;
	int data_len;
	int arg_count = ZEND_NUM_ARGS();
	struct ast_channel * chan;

	if(arg_count < 3) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &zchan TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(zchan));
		if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ls", &option, &data, &data_len) == FAILURE) {
			return;
		}
	} else {
		if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "sls", &channel, &channel_len, &option, &data, &data_len) == FAILURE) {
			return;
		}
		chan = asterisk_get_channel_by_name(channel);
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	RETURN_LONG(ast_channel_setoption(chan, option, data, data_len, 0));
}
/* }}} */


/* {{{ proto int asterisk_channel_status([string channel])
  Get channel status */
PHP_FUNCTION(asterisk_channel_status)
{
	zval **args[1];
	zval channel;
	int arg_count = ZEND_NUM_ARGS();

	struct ast_channel * chan;

	if (arg_count > 1 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	if(arg_count < 1) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));
	} else {
		convert_to_string_ex(args[0]);
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	RETURN_LONG(chan->_state);
}
/* }}} */


/* {{{ proto int asterisk_cli(int fd, string cmd)
  CLI */
PHP_FUNCTION(asterisk_cli)
{
/* TODO: test
   this command is broken
 */
	long fd = 0;
	char * cmd = NULL;
	int cmd_len = 0;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fd, &cmd, &cmd_len) == FAILURE) {
		return;
	}
/*
	ast_cli(fd, cmd);
*/
	RETURN_LONG(0);
}
/* }}} */


/* {{{ proto string asterisk_codec2str(int codec)
  CLI */
PHP_FUNCTION(asterisk_codec2str)
{
	int codec = 0;
	char * c;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "l", &codec) == FAILURE) {
		return;
	}

	c = ast_codec2str(codec);
	RETURN_STRING(c, strlen(c));
}
/* }}} */


/* {{{ proto int asterisk_control_streamfile([string channel,] string file, string fwd, string rev, string stop, string pause[, int skipms])
  Stream a file with controls */
PHP_FUNCTION(asterisk_control_streamfile)
{
/* TODO: test */
	char * channel = NULL;
	int channel_len = 0;
	char * file = NULL;
	int file_len = 0;
	char * fwd = NULL;
	int fwd_len = 0;
	char * rev = NULL;
	int rev_len = 0;
	char * stop = NULL;
	int stop_len = 0;
	char * pause = NULL;
	int pause_len = 0;
	long skipms = 0;
	struct ast_channel * chan;
	zval ch;

	if(ZEND_NUM_ARGS() == 5) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &ch TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(ch));
		if(zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "sssss", &file, &file_len, &fwd, &fwd_len, &rev, &rev_len, &stop, &stop_len, &pause, &pause_len) == FAILURE) {
			return;
		}
	}
	else if(ZEND_NUM_ARGS() == 6) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &ch TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(ch));
		if(zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "sssssl", &file, &file_len, &fwd, &fwd_len, &rev, &rev_len, &stop, &stop_len, &pause, &pause_len, &skipms) == FAILURE) {
			return;
		}
	} else {
		if(zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ssssssl", &channel, &channel_len, &file, &file_len, &fwd, &fwd_len, &rev, &rev_len, &stop, &stop_len, &pause, &pause_len, &skipms) == FAILURE) {
			return;
		}
		chan = asterisk_get_channel_by_name(channel);
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	RETURN_LONG(ast_control_streamfile(chan, file, fwd, rev, stop, pause, skipms));
}
/* }}} */


/* {{{ proto int asterisk_db_del(string family, string keys)
  Delete a database value */
PHP_FUNCTION(asterisk_db_del)
{
/* TODO: test */
	char * family = NULL;
	int family_len = 0;
	char * keys = NULL;
	int keys_len = 0;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ss", &family, &family_len, &keys, &keys_len) == FAILURE) {
		return;
	}

	RETURN_LONG(ast_db_del(family, keys));
}
/* }}} */


/* {{{ proto int asterisk_db_deltree(string family[, string keytree])
  Delete a database family */
PHP_FUNCTION(asterisk_db_deltree)
{
/* TODO: test */
	zval **args[2];
	int arg_count = ZEND_NUM_ARGS();

	if (arg_count > 2 || arg_count < 1 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	convert_to_string_ex(args[0]);
	if(arg_count == 2) {
		convert_to_string_ex(args[1]);
		RETURN_LONG(ast_db_deltree(Z_STRVAL_PP(args[0]), Z_STRVAL_PP(args[1])));
	} else {
		RETURN_LONG(ast_db_deltree(Z_STRVAL_PP(args[0]), NULL));
	}
}
/* }}} */


/* {{{ proto int asterisk_db_get(string family, string keys)
  Get a database value */
PHP_FUNCTION(asterisk_db_get)
{
/* TODO: test
need to pass return by reference and return res
 */
	char * family = NULL;
	int family_len = 0;
	char * keys = NULL;
	int keys_len = 0;
	int res;
	char tmp[256] = {""};
	char *ptr;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ss", &family, &family_len, &keys, &keys_len) == FAILURE) {
		return;
	}

	res = ast_db_get(family, keys, tmp, sizeof(tmp));
	ptr = tmp;

	if(ptr) {
		RETURN_STRING(ptr, strlen(ptr));
	}

	RETURN_NULL();
}
/* }}} */


/* {{{ proto int asterisk_db_put(string family, string keys, string value)
  Put a database value */
PHP_FUNCTION(asterisk_db_put)
{
/* TODO: test */
	char * family = NULL;
	int family_len = 0;
	char * keys = NULL;
	int keys_len = 0;
	char * value = NULL;
	int value_len = 0;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "sss", &family, &family_len, &keys, &keys_len, &value, &value_len) == FAILURE) {
		return;
	}

	RETURN_LONG(ast_db_put(family, keys, value));
}
/* }}} */


/* {{{ proto int asterisk_exec([string channel,] string app[, string data])
  Execute an app */
PHP_FUNCTION(asterisk_exec)
{
	zval **args[3];
	zval channel;
	char * data = NULL;
	char * app_name = NULL;
	int arg_count = ZEND_NUM_ARGS();
	struct ast_app *app;
	struct ast_channel * chan;

	if (arg_count > 3 || arg_count < 1 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	if(arg_count < 3) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));
		convert_to_string_ex(args[0]);
		app_name = Z_STRVAL_PP(args[0]);
	} else {
		convert_to_string_ex(args[0]);
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
		convert_to_string_ex(args[1]);
		app_name = Z_STRVAL_PP(args[1]);
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	app = (struct ast_app *)pbx_findapp(app_name);
	if(!app) {
		ast_log(LOG_WARNING, "Could not find application (%s)\n", app_name);
		RETURN_LONG(-1);
	}

	if(arg_count > 1) {
		convert_to_string_ex(args[arg_count - 1]);
		data = Z_STRVAL_PP(args[arg_count - 1]);
	}

	RETURN_LONG(pbx_exec(chan, app, data, 1));
}
/* }}} */


/* {{{ proto string asterisk_getdata([string channel,] string filename[, int maxdigits[, int timeout]])
  Get data */
PHP_FUNCTION(asterisk_getdata)
{
/* TODO: test
need to pass return by reference and return res
 */
	zval **args[4];
	zval channel;
	struct ast_channel * chan;
	char * filename;
	int maxdigits = 1024;
	int timeout = 0;
	int res;
	char data[1024] = {""};
	int arg_count = ZEND_NUM_ARGS();

	if (arg_count > 4 || arg_count < 1 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	convert_to_string_ex(args[0]);
	if(arg_count < 4) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));
		filename = Z_STRVAL_PP(args[0]);
		if(arg_count > 1) {
			convert_to_long_ex(args[1]);
			maxdigits = Z_LVAL_PP(args[1]);
			if(arg_count > 2) {
				convert_to_long_ex(args[2]);
				timeout = Z_LVAL_PP(args[2]);
			}			
		}
	} else {
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
		convert_to_string_ex(args[1]);
		filename = Z_STRVAL_PP(args[1]);
		convert_to_long_ex(args[2]);
		maxdigits = Z_LVAL_PP(args[2]);
		convert_to_long_ex(args[3]);
		timeout = Z_LVAL_PP(args[3]);
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	res = ast_app_getdata(chan, filename, data, maxdigits, timeout);
	if(!res) {
		if(data[0]) {
			RETURN_STRING(data, strlen(data));
		} else {
			RETURN_EMPTY_STRING();
		}
	}

	RETURN_LONG(res);
}
/* }}} */


/* {{{ proto int asterisk_getformatbyname(string name)
  Get format by name */
PHP_FUNCTION(asterisk_getformatbyname)
{
	char * format;
	int format_len;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s", &format, &format_len) == FAILURE) {
		return;
	}

	RETURN_LONG(ast_getformatbyname(format));
}
/* }}} */


/* {{{ proto string asterisk_getformatname(int format)
  Get format name */
PHP_FUNCTION(asterisk_getformatname)
{
	long format = 0;
	char * f;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "l", &format) == FAILURE) {
		return;
	}

	f = ast_getformatname(format);
	RETURN_STRING(f, strlen(f));
}
/* }}} */


/* {{{ proto int asterisk_get_priority([string channel])
  Set priority */
PHP_FUNCTION(asterisk_get_priority)
{
	zval **args[1];
	zval channel;
	int arg_count = ZEND_NUM_ARGS();

	struct ast_channel * chan;

	if (arg_count > 1 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	if(arg_count < 1) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));
	} else {
		convert_to_string_ex(args[0]);
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	RETURN_LONG(chan->priority);
}
/* }}} */


/* {{{ proto string asterisk_get_variable([string channel,] string variable)
  Get a channel variable */
PHP_FUNCTION(asterisk_get_variable)
{
	zval **args[2];
	zval channel;
	char * res;
	int arg_count = ZEND_NUM_ARGS();

	struct ast_channel * chan;

	if (arg_count > 2 || arg_count < 1 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	convert_to_string_ex(args[0]);
	if(arg_count < 2) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));
	} else {
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
		convert_to_string_ex(args[1]);
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	res = (char *) pbx_builtin_getvar_helper(chan, Z_STRVAL_PP(args[arg_count - 1]));

	RETURN_STRING(res, strlen(res));
}
/* }}} */


/* {{{ proto array asterisk_get_variables([string channel])
  Get channel variables */
PHP_FUNCTION(asterisk_get_variables)
{
/* TODO: test
get globals
 */
	zval **args[1];
	zval channel;
	char * res;
	struct ast_channel * chan;
        struct ast_var_t *variables;
        struct varshead *headp;
	int arg_count = ZEND_NUM_ARGS();

	if (arg_count > 1 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	if(arg_count < 1) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));
	} else {
		convert_to_string_ex(args[0]);
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
	}

	if(chan) {
		headp = &chan->varshead;
	} else {
/*
                headp = &globals;
*/
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	array_init(return_value);

	AST_LIST_TRAVERSE(headp, variables, entries) {
		add_assoc_string(return_value, variables->name, variables->value, 1);
	}
#if 0
	if(headp != &globals) {
		/* Check global variables if we haven't already */
		headp = &globals;
		AST_LIST_TRAVERSE(headp,variables,entries) {
			add_assoc_string(return_value, variables->name, variables->value, 1);
		}
	}
#endif
}
/* }}} */


/* {{{ proto int asterisk_hangup([[string channel,] int cause])
  Soft hangup a channel */
PHP_FUNCTION(asterisk_hangup)
{
/* TODO: test */
	zval **args[2];
	zval channel;
	int arg_count = ZEND_NUM_ARGS();
	int cause = AST_SOFTHANGUP_EXPLICIT;

	struct ast_channel * chan;

	if (arg_count > 2 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	if(arg_count < 2) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));
	} else {
		convert_to_string_ex(args[0]);
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	if(arg_count != 0) {
		convert_to_long_ex(args[arg_count - 1]);
		cause = Z_LVAL_PP(args[arg_count - 1]);
	}

	RETURN_LONG(ast_softhangup(chan, cause));
}
/* }}} */


/* {{{ proto asterisk_log(long log, string message)
  Log */
PHP_FUNCTION(asterisk_log)
{
/* TODO: test */
	int log = 0;
	char * message = NULL;
	int message_len = 0;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ls", &log, &message, &message_len) == FAILURE) {
		return;
	}

	ast_log(log, __FILE__, __LINE__, __PRETTY_FUNCTION__, message);
}
/* }}} */


/* {{{ proto int asterisk_manager_command(int fd, string cmd)
  Manager command */
PHP_FUNCTION(asterisk_manager_command)
{
/* TODO: test
optional parameters
what does this do?
broken
 */
	long fd = 0;
	char * cmd = NULL;
	int cmd_len = 0;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fd, &cmd, &cmd_len) == FAILURE) {
		return;
	}

	RETURN_LONG(ast_cli_command(fd, cmd));
}
/* }}} */


/* {{{ proto asterisk_moh_start([[string channel,] string class])
  Start music on hold */
PHP_FUNCTION(asterisk_moh_start)
{
/* TODO: test */
	zval **args[2];
	zval channel;
	int arg_count = ZEND_NUM_ARGS();

	struct ast_channel * chan;

	if (arg_count > 2 || arg_count < 1 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	if(arg_count < 2) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));
	} else {
		convert_to_string_ex(args[0]);
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	convert_to_string_ex(args[arg_count - 1]);
	if(arg_count == 0 || strlen(Z_STRVAL_PP(args[arg_count - 1])) == 0) {
		ast_moh_start(chan, NULL);
	}
	else {
		ast_moh_start(chan, Z_STRVAL_PP(args[arg_count - 1]));
	}
}
/* }}} */


/* {{{ proto asterisk_moh_stop([string channel])
  Stop music on hold */
PHP_FUNCTION(asterisk_moh_stop)
{
/* TODO: test */
	zval **args[1];
	zval channel;
	int arg_count = ZEND_NUM_ARGS();

	struct ast_channel * chan;

	if (arg_count > 1 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	if(arg_count < 1) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));
	} else {
		convert_to_string_ex(args[0]);
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	ast_moh_stop(chan);
}
/* }}} */


/* {{{ proto int asterisk_recvchar([[string channel,] int timeout])
  Receive a character */
PHP_FUNCTION(asterisk_recvchar)
{
/* TODO: test */
	zval **args[2];
	zval channel;
	int timeout = 0;
	int arg_count = ZEND_NUM_ARGS();

	struct ast_channel * chan;

	if (arg_count > 2 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	if(arg_count < 2) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));
	} else {
		convert_to_string_ex(args[0]);
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
	}

	if(arg_count) {
		convert_to_long_ex(args[arg_count - 1]);
		timeout = Z_LVAL_PP(args[arg_count - 1]);
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	RETURN_LONG(ast_recvchar(chan, timeout));
}
/* }}} */


/* {{{ proto string asterisk_request(string type, int format, string data, int &cause)
  Request */
PHP_FUNCTION(asterisk_request)
{
/* TODO: test */
	char * type = NULL;
	int type_len = 0;
	long format = 0;
	char * data = NULL;
	int data_len = 0;

#ifdef AST_FLAG_BLOCKING
	int cause = 0;
#endif

	struct ast_channel *chan=NULL;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "sls", &type, &type_len, &format, &data, &data_len) == FAILURE) {
		return;
	}

#ifdef AST_FLAG_BLOCKING
	chan = ast_request(type, format, data, &cause);
#else
	chan = ast_request(type, format, data);
#endif

	RETURN_STRING(chan->name, strlen(chan->name));
}
/* }}} */


/* {{{ proto string asterisk_request_and_dial(string type, int format, string data, int timeoute, int outstate, string callerid)
  ??? */
PHP_FUNCTION(asterisk_request_and_dial)
{
/* TODO: test
optional parameters
needs to pass by reference
 */
	char * type = NULL;
	int type_len = 0;
	long format = 0;
	char * data = NULL;
	int data_len = 0;
	long timeout = 0;
	int outstate;
	char * callerid = NULL;

#ifdef AST_FLAG_BLOCKING
	char cidname[MAX_CALLERID_SIZE], cidnum[MAX_CALLERID_SIZE];
#endif

	int callerid_len = 0;
	struct ast_channel *chan;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "slslls", &type, &type_len, &format, &data, &data_len, &timeout, &outstate, &callerid, &callerid_len) == FAILURE) {
		return;
	}
#ifdef AST_FLAG_BLOCKING
	ast_callerid_split(callerid, cidname, sizeof(cidname), cidnum, sizeof(cidnum));
	chan = ast_request_and_dial(type, format, data, timeout, &outstate, cidnum, cidname);
#else
	chan = ast_request_and_dial(type, format, data, timeout, &outstate, callerid);
#endif

	RETURN_STRING(chan->name, strlen(chan->name));
}
/* }}} */


/* {{{ proto int asterisk_say_character_str([string channel,] string chars, [string ints[, string lang]])
  Say digits */
PHP_FUNCTION(asterisk_say_character_str)
{
/* TODO: test */
	zval **args[4];
	zval channel;
	char * chars = NULL;
	char * ints = NULL;
	char * lang = NULL;
	int i;
	int arg_count = ZEND_NUM_ARGS();

	struct ast_channel * chan;

	if (arg_count > 4 || arg_count < 1 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	for(i = 0; i < arg_count; i++) {
		convert_to_string_ex(args[i]);
	}

	if(arg_count < 4) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));
		chars = Z_STRVAL_PP(args[0]);
		if(arg_count >= 2) {
			ints = Z_STRVAL_PP(args[1]);
			if(arg_count == 3) {
				lang = Z_STRVAL_PP(args[2]);
			}
		}
	} else {
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
		chars = Z_STRVAL_PP(args[1]);
		ints = Z_STRVAL_PP(args[2]);
		lang = Z_STRVAL_PP(args[3]);
		arg_count++;
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	if(lang == NULL) {
		lang = chan->language;
	}

	RETURN_LONG(ast_say_character_str(chan, chars, ints, lang));
}
/* }}} */


/* {{{ proto int asterisk_say_date([string channel,] [int time[, string ints[, string lang[, string format[, string timezone]]]]])
  Say the date */
PHP_FUNCTION(asterisk_say_date)
{
/* TODO: test */
	zval **args[6];
	zval channel;
	int t;
	char * ints = NULL;
	char * lang = NULL;
	char * format = NULL;
	char * timezone = NULL;

	int arg_count = ZEND_NUM_ARGS();

	struct ast_channel * chan;

	if (arg_count > 6 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	if(arg_count < 6) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));

		if(arg_count > 0) {
			convert_to_long_ex(args[0]);
			t = Z_LVAL_PP(args[0]);
			if(arg_count > 1) {
				convert_to_string_ex(args[1]);
				ints = Z_STRVAL_PP(args[1]);
				if(arg_count > 2) {
					convert_to_string_ex(args[2]);
					lang = Z_STRVAL_PP(args[2]);
					if(arg_count > 3) {
						convert_to_string_ex(args[3]);
						format = Z_STRVAL_PP(args[3]);
						if(arg_count > 4) {
							convert_to_string_ex(args[4]);
							timezone = Z_STRVAL_PP(args[4]);
						}
					}
				}
			}
		} else {
			t = time(NULL);
		}
	} else {
		convert_to_string_ex(args[0]);
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
		convert_to_long_ex(args[1]);
		t = Z_LVAL_PP(args[1]);
		convert_to_string_ex(args[2]);
		ints = Z_STRVAL_PP(args[2]);
		convert_to_string_ex(args[3]);
		lang = Z_STRVAL_PP(args[3]);
		convert_to_string_ex(args[4]);
		format = Z_STRVAL_PP(args[4]);
		convert_to_string_ex(args[5]);
		timezone = Z_STRVAL_PP(args[5]);
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	if(lang == NULL) {
		lang = chan->language;
	}

	if(arg_count > 3) {
		RETURN_LONG(ast_say_date_with_format(chan, t, ints, lang, format, timezone));
	} else {
		RETURN_LONG(ast_say_date(chan, t, ints, lang));
	}
}
/* }}} */


/* {{{ proto int asterisk_say_datetime([string channel,] [int time[, string ints[, string lang]]])
  Say the date and time */
PHP_FUNCTION(asterisk_say_datetime)
{
/* TODO: test */
	zval **args[4];
	zval channel;
	int t;
	char * ints = NULL;
	char * lang = NULL;

	int arg_count = ZEND_NUM_ARGS();

	struct ast_channel * chan;

	if (arg_count > 4 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	if(arg_count < 4) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));

		if(arg_count > 0) {
			convert_to_long_ex(args[0]);
			t = Z_LVAL_PP(args[0]);
			if(arg_count > 1) {
				convert_to_string_ex(args[1]);
				ints = Z_STRVAL_PP(args[1]);
				if(arg_count > 2) {
					convert_to_string_ex(args[2]);
					lang = Z_STRVAL_PP(args[2]);
				}
			}
		} else {
			t = time(NULL);
		}
	} else {
		convert_to_string_ex(args[0]);
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
		convert_to_long_ex(args[1]);
		t = Z_LVAL_PP(args[1]);
		convert_to_string_ex(args[2]);
		ints = Z_STRVAL_PP(args[2]);
		convert_to_string_ex(args[3]);
		lang = Z_STRVAL_PP(args[3]);
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	if(lang == NULL) {
		lang = chan->language;
	}

	RETURN_LONG(ast_say_datetime(chan, t, ints, lang));
}
/* }}} */


/* {{{ proto int asterisk_say_datetime_from_now([string channel,] [int time[, string ints[, string lang]]])
  Say the date and time from now*/
PHP_FUNCTION(asterisk_say_datetime_from_now)
{
/* TODO: test */
	zval **args[4];
	zval channel;
	int t;
	char * ints = NULL;
	char * lang = NULL;

	int arg_count = ZEND_NUM_ARGS();

	struct ast_channel * chan;

	if (arg_count > 4 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	if(arg_count < 4) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));

		if(arg_count > 0) {
			convert_to_long_ex(args[0]);
			t = Z_LVAL_PP(args[0]);
			if(arg_count > 1) {
				convert_to_string_ex(args[1]);
				ints = Z_STRVAL_PP(args[1]);
				if(arg_count > 2) {
					convert_to_string_ex(args[2]);
					lang = Z_STRVAL_PP(args[2]);
				}
			}
		} else {
			t = time(NULL);
		}
	} else {
		convert_to_string_ex(args[0]);
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
		convert_to_long_ex(args[1]);
		t = Z_LVAL_PP(args[1]);
		convert_to_string_ex(args[2]);
		ints = Z_STRVAL_PP(args[2]);
		convert_to_string_ex(args[3]);
		lang = Z_STRVAL_PP(args[3]);
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	if(lang == NULL) {
		lang = chan->language;
	}

	RETURN_LONG(ast_say_datetime_from_now(chan, t, ints, lang));
}
/* }}} */


/* {{{ proto int asterisk_say_digit_str([string channel,] string digits, [string ints[, string lang="en"]])
  Say digits */
PHP_FUNCTION(asterisk_say_digit_str)
{
/* TODO: test */
	zval **args[4];
	zval channel;
	char * digits = NULL;
	char * ints = NULL;
	char * lang = NULL;
	int i;
	int arg_count = ZEND_NUM_ARGS();

	struct ast_channel * chan;

	if (arg_count > 4 || arg_count < 1 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	for(i = 0; i < arg_count; i++) {
		convert_to_string_ex(args[i]);
	}

	if(arg_count < 4) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));
		digits = Z_STRVAL_PP(args[0]);
		if(arg_count >= 2) {
			ints = Z_STRVAL_PP(args[1]);
			if(arg_count == 3) {
				lang = Z_STRVAL_PP(args[2]);
			}
		}
	} else {
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
		digits = Z_STRVAL_PP(args[1]);
		ints = Z_STRVAL_PP(args[2]);
		lang = Z_STRVAL_PP(args[3]);
		arg_count++;
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	if(lang == NULL) {
		lang = chan->language;
	}

	RETURN_LONG(ast_say_digit_str(chan, digits, ints, lang));
}
/* }}} */


/* {{{ proto int asterisk_say_number([string channel], int number, [string ints[, string lang[, string options]]])
  Say a number */
PHP_FUNCTION(asterisk_say_number)
{
/* TODO: test */
	zval **args[5];
	zval channel;
	int number;
	char * ints = NULL;
	char * lang = NULL;
	char * options = NULL;

	int arg_count = ZEND_NUM_ARGS();

	struct ast_channel * chan;

	if (arg_count > 5 || arg_count < 1 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	if(arg_count < 5) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));
		convert_to_long_ex(args[0]);
		number = Z_LVAL_PP(args[0]);
		if(arg_count >= 2) {
			convert_to_string_ex(args[1]);
			ints = Z_STRVAL_PP(args[1]);
			if(arg_count >= 3) {
				convert_to_string_ex(args[2]);
				lang = Z_STRVAL_PP(args[2]);
				if(arg_count >= 4) {
					convert_to_string_ex(args[3]);
					options = Z_STRVAL_PP(args[3]);
				}
			}
		}
	} else {
		convert_to_string_ex(args[0]);
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
		convert_to_long_ex(args[1]);
		number = Z_LVAL_PP(args[1]);
		convert_to_string_ex(args[2]);
		ints = Z_STRVAL_PP(args[2]);
		convert_to_string_ex(args[3]);
		lang = Z_STRVAL_PP(args[3]);
		convert_to_string_ex(args[4]);
		options = Z_STRVAL_PP(args[4]);
		arg_count++;
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	if(lang == NULL) {
		lang = chan->language;
	}

	RETURN_LONG(ast_say_number(chan, number, ints, lang, options));
}
/* }}} */


/* {{{ proto int asterisk_say_phonetic_str([string channel,] string text[, string ints[, string lang]])
  Say phonetic */
PHP_FUNCTION(asterisk_say_phonetic_str)
{
/* TODO: test */
	zval **args[4];
	zval channel;
	char * text;
	char * ints = NULL;
	char * lang = NULL;

	int arg_count = ZEND_NUM_ARGS();

	struct ast_channel * chan;

	if (arg_count > 4 || arg_count < 1 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	if(arg_count < 4) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));
		convert_to_string_ex(args[0]);
		text = Z_STRVAL_PP(args[0]);
		if(arg_count > 1) {
			convert_to_string_ex(args[1]);
			ints = Z_STRVAL_PP(args[1]);
			if(arg_count > 2) {
				convert_to_string_ex(args[2]);
				lang = Z_STRVAL_PP(args[2]);
			}
		}
	} else {
		convert_to_string_ex(args[0]);
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
		convert_to_string_ex(args[1]);
		text = Z_STRVAL_PP(args[1]);
		convert_to_string_ex(args[2]);
		ints = Z_STRVAL_PP(args[2]);
		convert_to_string_ex(args[3]);
		lang = Z_STRVAL_PP(args[3]);
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	if(lang == NULL) {
		lang = chan->language;
	}

	RETURN_LONG(ast_say_phonetic_str(chan, text, ints, lang));
}
/* }}} */


/* {{{ proto int asterisk_say_time([string channel,] [int time[, string ints[, string lang]]])
  Say the time */
PHP_FUNCTION(asterisk_say_time)
{
/* TODO: test */
	zval **args[4];
	zval channel;
	int t;
	char * ints = NULL;
	char * lang = NULL;

	int arg_count = ZEND_NUM_ARGS();

	struct ast_channel * chan;

	if (arg_count > 4 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	if(arg_count < 4) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));

		if(arg_count > 0) {
			convert_to_long_ex(args[0]);
			t = Z_LVAL_PP(args[0]);
			if(arg_count > 1) {
				convert_to_string_ex(args[1]);
				ints = Z_STRVAL_PP(args[1]);
				if(arg_count > 2) {
					convert_to_string_ex(args[2]);
					lang = Z_STRVAL_PP(args[2]);
				}
			}
		} else {
			t = time(NULL);
		}
	} else {
		convert_to_string_ex(args[0]);
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
		convert_to_long_ex(args[1]);
		t = Z_LVAL_PP(args[1]);
		convert_to_string_ex(args[2]);
		ints = Z_STRVAL_PP(args[2]);
		convert_to_string_ex(args[3]);
		lang = Z_STRVAL_PP(args[3]);
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	if(lang == NULL) {
		lang = chan->language;
	}

	RETURN_LONG(ast_say_time(chan, t, ints, lang));
}
/* }}} */


/* {{{ proto int asterisk_senddigit([string channel,] string digit)
  Send a dtmf digit */
PHP_FUNCTION(asterisk_senddigit)
{
/* TODO: test */
	zval **args[2];
	zval channel;
	char * digit;
	int arg_count = ZEND_NUM_ARGS();

	struct ast_channel * chan;

	if (arg_count > 2 || arg_count < 1 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	if(arg_count < 2) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));
	} else {
		convert_to_string_ex(args[0]);
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	convert_to_string_ex(args[arg_count - 1]);
	digit = Z_STRVAL_PP(args[arg_count - 1]);

	RETURN_LONG(ast_senddigit(chan, digit[0]));
}
/* }}} */


/* {{{ proto int asterisk_send_image([string channel,] string image)
  Send an image */
PHP_FUNCTION(asterisk_send_image)
{
/* TODO: test */
	zval **args[2];
	zval channel;
	int arg_count = ZEND_NUM_ARGS();

	struct ast_channel * chan;

	if (arg_count > 2 || arg_count < 1 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	if(arg_count < 2) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));
	} else {
		convert_to_string_ex(args[0]);
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	convert_to_string_ex(args[arg_count - 1]);
	RETURN_LONG(ast_send_image(chan, Z_STRVAL_PP(args[arg_count - 1])));
}
/* }}} */


/* {{{ proto int asterisk_sendtext([string channel,] string text)
  Send text */
PHP_FUNCTION(asterisk_sendtext)
{
/* TODO: test */
	zval **args[2];
	zval channel;
	int arg_count = ZEND_NUM_ARGS();

	struct ast_channel * chan;

	if (arg_count > 2 || arg_count < 1 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	if(arg_count < 2) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));
	} else {
		convert_to_string_ex(args[0]);
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	convert_to_string_ex(args[arg_count - 1]);
	RETURN_LONG(ast_sendtext(chan, Z_STRVAL_PP(args[arg_count - 1])));
}
/* }}} */


/* {{{ proto asterisk_set_best_read_format([string channel])
  Set best read format */
PHP_FUNCTION(asterisk_set_best_read_format)
{
/* TODO: test
needs a parameter, renamed?
 */
	zval **args[1];
	zval channel;
	int arg_count = ZEND_NUM_ARGS();

	struct ast_channel * chan;

	if (arg_count > 1 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	if(arg_count) {
		convert_to_string_ex(args[0]);
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
	} else {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	ast_set_read_format_a(chan, ast_best_codec(chan->nativeformats));
}
/* }}} */


/* {{{ proto asterisk_set_best_write_format([string channel])
  Set best write format */
PHP_FUNCTION(asterisk_set_best_write_format)
{
/* TODO: test
needs a parameter, renamed?
 */
	zval **args[1];
	zval channel;
	int arg_count = ZEND_NUM_ARGS();

	struct ast_channel * chan;

	if (arg_count > 1 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	if(arg_count) {
		convert_to_string_ex(args[0]);
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
	} else {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	ast_set_write_format_a(chan, ast_best_codec(chan->nativeformats));
}
/* }}} */


/* {{{ proto asterisk_set_callerid([string channel,] string callerid[, boolean anitoo])
  Set Caller ID */
PHP_FUNCTION(asterisk_set_callerid)
{
/* TODO: test */
	zval **args[3];
	zval channel;
	char * callerid = NULL;
	int anitoo = 0;
	int arg_count = ZEND_NUM_ARGS();

#ifdef AST_FLAG_BLOCKING
	char ourcidname[MAX_CALLERID_SIZE], ourcidnum[MAX_CALLERID_SIZE];
#endif

	struct ast_channel * chan;

	if (arg_count > 3 || arg_count < 1 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	convert_to_string_ex(args[0]);
	if(arg_count < 3) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));
		callerid = Z_STRVAL_PP(args[0]);
		if(arg_count > 1) {
			convert_to_boolean_ex(args[1]);
			anitoo = Z_BVAL_PP(args[1]);
		}
	} else {
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
		convert_to_string_ex(args[1]);
		callerid = Z_STRVAL_PP(args[1]);
		convert_to_boolean_ex(args[2]);
		anitoo = Z_BVAL_PP(args[2]);
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

#ifdef AST_FLAG_BLOCKING
	ast_callerid_split(callerid, ourcidname, sizeof(ourcidname), ourcidnum, sizeof(ourcidnum));
	ast_set_callerid(chan, ourcidnum, ourcidname, ourcidnum);
#else
	ast_set_callerid(chan, callerid, anitoo);
#endif

}
/* }}} */


/* {{{ proto int asterisk_set_context([string channel,] string context)
  Set context */
PHP_FUNCTION(asterisk_set_context)
{
/* TODO: test */
	zval **args[2];
	zval channel;
	int arg_count = ZEND_NUM_ARGS();

	struct ast_channel * chan;

	if (arg_count > 2 || arg_count < 1 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	if(arg_count < 2) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));
	} else {
		convert_to_string_ex(args[0]);
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	convert_to_string_ex(args[arg_count - 1]);
	strncpy(chan->context, Z_STRVAL_PP(args[arg_count - 1]), sizeof(chan->context)-1);
	RETURN_LONG(1);
}
/* }}} */


/* {{{ proto int asterisk_set_extension([string channel,] string exten)
  Set extension */
PHP_FUNCTION(asterisk_set_extension)
{
/* TODO: test */
	zval **args[2];
	zval channel;
	int arg_count = ZEND_NUM_ARGS();

	struct ast_channel * chan;

	if (arg_count > 2 || arg_count < 1 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	if(arg_count < 2) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));
	} else {
		convert_to_string_ex(args[0]);
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	convert_to_string_ex(args[arg_count - 1]);
	strncpy(chan->exten, Z_STRVAL_PP(args[arg_count - 1]), sizeof(chan->exten)-1);
	RETURN_LONG(0);
}
/* }}} */


/* {{{ proto int asterisk_set_priority([string channel,] int priority)
  Set priority */
PHP_FUNCTION(asterisk_set_priority)
{
/* TODO: test */
	zval **args[2];
	zval channel;
	int arg_count = ZEND_NUM_ARGS();

	struct ast_channel * chan;

	if (arg_count > 2 || arg_count < 1 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	if(arg_count < 2) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));
	} else {
		convert_to_string_ex(args[0]);
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	convert_to_long_ex(args[arg_count - 1]);
	chan->priority = Z_LVAL_PP(args[arg_count - 1]) - 1;
	RETURN_LONG(1);
}
/* }}} */


/* {{{ proto asterisk_set_read_format([string channel,] int format)
  Set read format */
PHP_FUNCTION(asterisk_set_read_format)
{
/* TODO: test */
	zval **args[2];
	zval channel;
	int arg_count = ZEND_NUM_ARGS();

	struct ast_channel * chan;

	if (arg_count > 2 || arg_count < 1 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	if(arg_count < 2) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));
	} else {
		convert_to_string_ex(args[0]);
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	convert_to_long_ex(args[arg_count - 1]);
	ast_set_read_format_a(chan, Z_LVAL_PP(args[arg_count - 1]));
}
/* }}} */


/* {{{ proto int asterisk_set_variable([string channel,] string variable, string value)
  Set a channel variable */
PHP_FUNCTION(asterisk_set_variable)
{
	zval **args[3];
	zval channel;
	int arg_count = ZEND_NUM_ARGS();

	struct ast_channel * chan;

	if (arg_count > 3 || arg_count < 2 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	if(arg_count < 3) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));
	} else {
		convert_to_string_ex(args[0]);
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	convert_to_string_ex(args[arg_count - 2]);
	convert_to_string_ex(args[arg_count - 1]);
	pbx_builtin_setvar_helper(chan, Z_STRVAL_PP(args[arg_count - 2]), Z_STRVAL_PP(args[arg_count - 1]));
	RETURN_LONG(0);
}
/* }}} */


/* {{{ proto int asterisk_setwhentohangup([[string channel,] int timeout])
  Cause the channel to automatically hangup at <time> seconds in the future. */
PHP_FUNCTION(asterisk_setwhentohangup)
{
/* todo: use ast_channel_setwhentohangup instead? */
	zval **args[2];
	zval channel;
	time_t timeout = 0;
	int arg_count = ZEND_NUM_ARGS();

	struct ast_channel * chan;

	if (arg_count > 2 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	if(arg_count < 2) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));
	} else {
		convert_to_string_ex(args[0]);
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	if(arg_count > 0)
	{
		convert_to_long_ex(args[arg_count - 1]);
		timeout = Z_LVAL_PP(args[arg_count - 1]);
		if (timeout < 0) {
			timeout = 0;
		}
	}

	ast_channel_setwhentohangup(chan, timeout);

	RETURN_LONG(0);
}
/* }}} */


/* {{{ proto asterisk_set_write_format([string channel,] int format)
  Set write format */
PHP_FUNCTION(asterisk_set_write_format)
{
/* TODO: test */
	zval **args[2];
	zval channel;
	int arg_count = ZEND_NUM_ARGS();

	struct ast_channel * chan;

	if (arg_count > 2 || arg_count < 1 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	if(arg_count < 2) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));
	} else {
		convert_to_string_ex(args[0]);
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	convert_to_string_ex(args[arg_count - 1]);
	ast_set_write_format_a(chan, Z_LVAL_PP(args[arg_count - 1]));
}
/* }}} */


/* {{{ proto string asterisk_state2str(int state)
  CLI */
PHP_FUNCTION(asterisk_state2str)
{
	int state = 0;
	char * s;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "l", &state) == FAILURE) {
		return;
	}

	s = ast_state2str(state);
	RETURN_STRING(s, strlen(s));
}
/* }}} */


/* {{{ proto int asterisk_stream_file([string channel,] string filename[, string digits[, int offset[, string lang]]])
  Stream a file */
PHP_FUNCTION(asterisk_stream_file)
{
/* TODO: test */
	zval **args[5];
	zval channel;
	char * filename = NULL;
	char * digits = NULL;
	long offset = 0;
	char * lang;
	int arg_count = ZEND_NUM_ARGS();
	int res;
	struct ast_filestream *fs;
	long max_length;
	int input;

	struct ast_channel * chan;

	if (arg_count > 5 || arg_count < 1 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	convert_to_string_ex(args[0]);
	convert_to_string_ex(args[1]);
	if(arg_count < 5) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));
		filename = Z_STRVAL_PP(args[0]);
		if(arg_count > 1) {
			digits = Z_STRVAL_PP(args[1]);
			if(arg_count > 2) {
				convert_to_long_ex(args[2]);
				offset = Z_LVAL_PP(args[2]);
				if(arg_count > 3) {
					convert_to_string_ex(args[3]);
					lang = Z_STRVAL_PP(args[3]);
				}
			}
		}
	} else {
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
		filename = Z_STRVAL_PP(args[1]);
		convert_to_string_ex(args[2]);
		digits = Z_STRVAL_PP(args[2]);
		convert_to_long_ex(args[3]);
		offset = Z_LVAL_PP(args[3]);
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	if(!lang) {
		lang = chan->language;
	}

	if(!filename) {
		ast_log(LOG_WARNING, "No Filename!\n");
		RETURN_LONG(-1);
	}

	if(!digits) {
		digits = "";
	}

	res = ast_waitfor(chan, -1);
	input = ast_waitfordigit(chan,100);
	if(input < 0)
		RETURN_LONG(-1);

	fs = (struct ast_filestream *) ast_openstream(chan, filename, lang);
	if(!fs){
		ast_log(LOG_WARNING, "Unable to open %s\n", filename);
		RETURN_LONG(-1);
	}
	ast_seekstream(fs, 0, SEEK_END);
	max_length = ast_tellstream(fs);
	ast_seekstream(fs, offset, SEEK_SET);
	res = ast_applystream(chan, fs);
	res = ast_playstream(fs);
	if (res) {
			RETURN_LONG(-1);
	}
	res = ast_waitstream(chan,digits);
	offset = (chan->stream) ? ast_tellstream(fs) : max_length;
	ast_stopstream(chan);
	RETURN_LONG(res);
}
/* }}} */


/* {{{ proto int asterisk_tdd_mode([[string channel,] int mode])
  Set tdd mode */
PHP_FUNCTION(asterisk_tdd_mode)
{
/* TODO: test */
	zval **args[2];
	zval channel;
	int mode = 1;
	int arg_count = ZEND_NUM_ARGS();

	struct ast_channel * chan;

	if (arg_count > 2 || arg_count < 1 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	if(arg_count < 2) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));
	} else {
		convert_to_string_ex(args[0]);
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	if(arg_count) {
		convert_to_long_ex(args[arg_count - 1]);
		mode = Z_LVAL_PP(args[arg_count - 1]);
	}

	RETURN_LONG(ast_channel_setoption(chan, AST_OPTION_TDD, &mode, sizeof(char), 0));
}
/* }}} */


/* {{{ proto asterisk_verbose(int level, string message)
  Verbose a message to the CLI */
PHP_FUNCTION(asterisk_verbose)
{
	int level = 0;
	char * message = NULL;
	int message_len = 0;
	char *prefix[] = {"", VERBOSE_PREFIX_1, VERBOSE_PREFIX_2, VERBOSE_PREFIX_3, VERBOSE_PREFIX_4};
	zval channel;
	struct ast_channel * chan;

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ls", &level, &message, &message_len) == FAILURE) {
		return;
	}

	if(level >= 0 && level < 4 && level <= option_verbose) {

		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));

		if(chan) {
			ast_verbose("%s %s: %s\n", prefix[level], chan->data, message);
		} else {
			ast_verbose("%s PHP: %s\n", prefix[level], message);
		}
	}
}
/* }}} */


/* {{{ proto asterisk_waitfor([string channel,] int wait)
  Wait */
PHP_FUNCTION(asterisk_waitfor)
{
/* TODO: test
what is wait?
 */
	zval **args[2];
	zval channel;
	char * mode;
	int m = 0;
	int arg_count = ZEND_NUM_ARGS();

	struct ast_channel * chan;

	if (arg_count > 2 || arg_count < 1 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	if(arg_count < 2) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));
	} else {
		convert_to_string_ex(args[0]);
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	convert_to_long_ex(args[arg_count - 1]);
	ast_waitfor(chan, Z_LVAL_PP(args[arg_count - 1]));
}
/* }}} */


/* {{{ proto int asterisk_waitfordigit([[string channel,] int timeout])
  Wait for a digit */
PHP_FUNCTION(asterisk_waitfordigit)
{
/* TODO: test */
	zval **args[2];
	zval channel;
	int timeout = -1;
	int arg_count = ZEND_NUM_ARGS();
	struct ast_channel * chan;

	if (arg_count > 2 || zend_get_parameters_array_ex(arg_count, args) == FAILURE) {
		WRONG_PARAM_COUNT;
	}

	if(arg_count < 2) {
		zend_get_constant("CHANNEL", sizeof("CHANNEL")-1, &channel TSRMLS_CC);
		chan = asterisk_get_channel_by_name(Z_STRVAL(channel));
	} else {
		convert_to_string_ex(args[0]);
		chan = asterisk_get_channel_by_name(Z_STRVAL_PP(args[0]));
	}

	if(!chan) {
		ast_log(LOG_WARNING, "No Channel!\n");
		RETURN_LONG(-1);
	}

	if(arg_count) {
		convert_to_long_ex(args[arg_count - 1]);
		timeout = Z_LVAL_PP(args[arg_count - 1]);
	}

	RETURN_LONG(ast_waitfordigit(chan, timeout));
}
/* }}} */


/*************/
/* SAPI part */
/*************/

static char* php_asterisk_read_cookies(TSRMLS_D)
{
	return NULL;
}

static int php_asterisk_deactivate(TSRMLS_D)
{
	fflush(stdout);
	return SUCCESS;
}

static inline size_t php_asterisk_single_write(const char *str, uint str_length)
{
ast_verbose("%s", str);
return str_length;

#if 0
#ifdef PHP_WRITE_STDOUT
	long ret;

	ret = write(STDOUT_FILENO, str, str_length);
	if (ret <= 0) return 0;
	return ret;
#else
	size_t ret;

	ret = fwrite(str, 1, MIN(str_length, 16384), stdout);
	return ret;
#endif
#endif
}


static int php_asterisk_ub_write(const char *str, uint str_length TSRMLS_DC)
{
	const char *ptr = str;
	uint remaining = str_length;
	size_t ret;

	while (remaining > 0) {
		ret = php_asterisk_single_write(ptr, remaining);
		if (!ret) {
			php_handle_aborted_connection();
		}
		ptr += ret;
		remaining -= ret;
	}
	return str_length;
}

static void php_asterisk_flush(void *server_context)
{
	if (fflush(stdout)==EOF) {
		php_handle_aborted_connection();
	}
}

void asterisk_error_handler(int type, const char *error_filename, const uint error_lineno, const char *format, va_list args)
{
	char *error_type_str;
	char *buffer;
	int buffer_len;
        TSRMLS_FETCH();

	buffer_len = vspprintf(&buffer, PG(log_errors_max_len), format, args);

	switch (type) {
		case E_ERROR:
		case E_CORE_ERROR:
		case E_COMPILE_ERROR:
		case E_USER_ERROR:
			error_type_str = "Fatal error";
			break;
		case E_WARNING:
		case E_CORE_WARNING:
		case E_COMPILE_WARNING:
		case E_USER_WARNING:
			error_type_str = "Warning";
			break;
		case E_PARSE:
			error_type_str = "Parse error";
			break;
		case E_NOTICE:
		case E_USER_NOTICE:
			error_type_str = "Notice";
			break;
		default:
			error_type_str = "Unknown error";
			break;
		}



	ast_verbose("PHP %s:  %s in %s on line %d\n", error_type_str, buffer, error_filename, error_lineno);

	efree(buffer);
}

static void php_asterisk_send_header(sapi_header_struct *sapi_header, void *server_context TSRMLS_DC)
{
}

static void php_asterisk_log_message(char *message)
{
	ast_verbose("%s", message);
/*
	fprintf (stderr, "%s\n", message);
*/
}

static void php_asterisk_register_variables(zval *track_vars_array TSRMLS_DC)
{
	php_import_environment_variables(track_vars_array TSRMLS_CC);
}

static int php_asterisk_startup(sapi_module_struct *sapi_module)
{
        if (php_module_startup(sapi_module, &asterisk_module_entry, 1)==FAILURE) {
                return FAILURE;
        }
        return SUCCESS;
}

sapi_module_struct php_asterisk_module = {
	"asterisk",				/* name */
	"PHP Asterisk",				/* pretty name */
	
	php_asterisk_startup,			/* startup */
	php_module_shutdown_wrapper,		/* shutdown */
  
	NULL,					/* activate */
	php_asterisk_deactivate,		/* deactivate */
  
	php_asterisk_ub_write,			/* unbuffered write */
	php_asterisk_flush,			/* flush */
	NULL,					/* get uid */
	NULL,					/* getenv */
  
	php_error,				/* error handler */
  
	NULL,					/* header handler */
	NULL,					/* send headers handler */
	php_asterisk_send_header,		/* send header handler */
	
	NULL,					/* read POST data */
	php_asterisk_read_cookies,		/* read Cookies */
  
	php_asterisk_register_variables,	/* register server variables */
	php_asterisk_log_message,		/* Log message */

	NULL,					/* Block interruptions */
	NULL,					/* Unblock interruptions */

	STANDARD_SAPI_MODULE_PROPERTIES
};
/* }}} */

int php_asterisk_init(int argc, char **argv PTSRMLS_DC)
{
	zend_llist global_vars;
#ifdef ZTS
	zend_compiler_globals *compiler_globals;
	zend_executor_globals *executor_globals;
	php_core_globals *core_globals;
	sapi_globals_struct *sapi_globals;
	void ***tsrm_ls;
#endif

#ifdef HAVE_SIGNAL_H
#if defined(SIGPIPE) && defined(SIG_IGN)
	signal(SIGPIPE, SIG_IGN); /* ignore SIGPIPE in standalone mode so
					 that sockets created via fsockopen()
					 don't kill PHP if the remote site
					 closes it.  in apache|apxs mode apache
					 does that for us!  thies@thieso.net
					 20000419 */
#endif
#endif

#ifdef PHP_WIN32
  _fmode = _O_BINARY;			/*sets default for file streams to binary */
  setmode(_fileno(stdin), O_BINARY);		/* make the stdio mode be binary */
  setmode(_fileno(stdout), O_BINARY);		/* make the stdio mode be binary */
  setmode(_fileno(stderr), O_BINARY);		/* make the stdio mode be binary */
#endif

#ifdef ZTS
  tsrm_startup(1, 1, 0, NULL);
#endif

#ifdef ZTS
  compiler_globals = ts_resource(compiler_globals_id);
  executor_globals = ts_resource(executor_globals_id);
  core_globals = ts_resource(core_globals_id);
  sapi_globals = ts_resource(sapi_globals_id);
  tsrm_ls = ts_resource(0);
  *ptsrm_ls = tsrm_ls;
#endif

  sapi_startup(&php_asterisk_module);

  if (php_asterisk_module.startup(&php_asterisk_module)==FAILURE) {
	  return FAILURE;
  }
 
  if (argv) {
	php_asterisk_module.executable_location = argv[0];
  }

  zend_llist_init(&global_vars, sizeof(char *), NULL, 0);  

  /* Set some Asterisk PHP defaults */
  SG(options) |= SAPI_OPTION_NO_CHDIR;
  zend_alter_ini_entry("register_argc_argv", 19, "1", 1, PHP_INI_SYSTEM, PHP_INI_STAGE_ACTIVATE);
  zend_alter_ini_entry("html_errors", 12, "0", 1, PHP_INI_SYSTEM, PHP_INI_STAGE_ACTIVATE);

  zend_alter_ini_entry("display_errors", 15, "1", 1, PHP_INI_SYSTEM, PHP_INI_STAGE_ACTIVATE);
  zend_alter_ini_entry("report_zend_debug", 18, "1", 1, PHP_INI_SYSTEM, PHP_INI_STAGE_ACTIVATE);
  zend_alter_ini_entry("output_buffering", 17, "1", 1, PHP_INI_SYSTEM, PHP_INI_STAGE_ACTIVATE);

  zend_alter_ini_entry("implicit_flush", 15, "1", 1, PHP_INI_SYSTEM, PHP_INI_STAGE_ACTIVATE);
  zend_alter_ini_entry("max_execution_time", 19, "0", 1, PHP_INI_SYSTEM, PHP_INI_STAGE_ACTIVATE);

  zend_error_cb = asterisk_error_handler;

  SG(request_info).argc=argc;
  SG(request_info).argv=argv;

  if (php_request_startup(TSRMLS_C) == FAILURE) {
	  php_module_shutdown(TSRMLS_C);
	  return FAILURE;
  }
  
  SG(headers_sent) = 1;
  SG(request_info).no_headers = 1;
  php_register_variable("PHP_SELF", argv[0], NULL TSRMLS_CC);

/*
  {
       zend_constant c;

        c.value.type = IS_STRING;
        c.value.value.str.val = "JELLO";
        c.value.value.str.len = sizeof("JELLO") - 1;
        c.flags = CONST_CS;
        c.name = zend_strndup("JELLO", sizeof("JELLO")-1);
        c.name_len = sizeof("JELLO")-1;
        c.module_number = 0;
        zend_register_constant(&c TSRMLS_CC);

  }
*/

  return SUCCESS;
}

void php_asterisk_shutdown(TSRMLS_D)
{
	php_request_shutdown((void *) 0);
	php_module_shutdown(TSRMLS_C);
	sapi_shutdown();
#ifdef ZTS
    tsrm_shutdown();
#endif
}
